# -*- coding: utf-8 -*-

# Main structure for the port of a block: id (itself - variable name - and parent), direction (in/out) and arity
class Port:
	def __init__(self, parentId, selfId, pType, arity, var_name = None):
		self.parent_id = parentId
		self.direction = pType
		self.arity = arity
		self.sid = selfId
		# port name - unique identifier for Isabelle code
		self.var_name = var_name
		self.split_list = None
		self.value = None
		
	def get_var_list(self):
		name = self.get_var_name()
		if self.arity == 1:
			return [name]
		return ["%s%d" % (name, i + 1) for i in range(self.arity)]
		
	def get_id(self):
		return self.sid

	def get_parent_id(self):
		return self.parent_id

	def get_direction(self):
		return self.direction

	def set_direction(self, value):
		self.direction = value
	
	def get_arity(self):
		return self.arity

	def set_arity(self, value):
		self.arity = value
		
	def get_var_name(self):
		return self.var_name
		
	def set_var_name(self,value):
		if self.var_name == None:
			self.var_name = value
	
	def get_value(self):
		return self.value
		
	def set_value(self, value):
		self.value = str(value)

	def split(self, start_index):
		if self.get_arity() == 1:
			return [self]
		if self.split_list == None:
			self.split_list = [Port(self.parent_id, start_index + i, self.direction, 1, "%s%d" % (self.var_name, i + 1)) for i in range(0, self.get_arity())]
		return self.split_list
			
	def __repr__(self):
		return '(%s, %s, %s, %s, %s)' % (self.parent_id, self.sid, self.direction, self.var_name, self.arity)


