# -*- coding: utf-8 -*-

from blocks.simulink_basic import *
from utilities.simulink_utilities import *
import utilities.simulink_globals 

# method that 
def feedback(definition_blocks, A, fb_vars):
	if fb_vars == []:
		return A
	else:
		'''if len(fb_vars) == 1:
			return Feedback(A, fb_vars)
		else:
			return SeqFeedback(definition_blocks, A, fb_vars)
		'''
		#print "FEEDBACK"
		return SeqFeedback(definition_blocks, A, fb_vars)

def feedback2(A, fb_vars, opt_comp):
	if fb_vars == []:
		return A
	else:
		#print "FEEDBACK"
		return Feedback(A, fb_vars, False, opt_comp)
	
# method that 
'''
def compose(A, B, opt_comp):
	if A == None:
		print B
		B_B_vars = [v for v in B.outport if v in B.inport]
		print B_B_vars
		if len(B_B_vars) > 0:
			return feedback2(B, B_B_vars, opt_comp)
		return B
		
		
	A_B_vars = [v for v in A.outport if v in B.inport]
	B_A_vars = [v for v in B.outport if v in A.inport]

	#print "FEEDBACK"

	if A_B_vars == [] and B_A_vars == []:
		return Product(A, B)
	
	elif len(B_A_vars) < len(A_B_vars):
		return feedback2(Serial(A, B, A_B_vars), B_A_vars, opt_comp)
	else:
		return feedback2(Serial(B, A, B_A_vars), A_B_vars, opt_comp)
'''

def compose_comp_feedback(A, opt_comp):
	A_A_vars = [v for v in A.outport if v in A.inport]
	if len(A_A_vars) > 0:
		return feedback2(A, A_A_vars, opt_comp)
	return A

def compose(A, B, opt_comp):
	if A == None:
		B_new = compose_comp_feedback(B, opt_comp)
		return B_new

	A_new = compose_comp_feedback(A, opt_comp)
	B_new = compose_comp_feedback(B, opt_comp)
		
	A_B_vars = [v for v in A_new.outport if v in B_new.inport]
	B_A_vars = [v for v in B_new.outport if v in A_new.inport]

	#print "FEEDBACK"

	if A_B_vars == [] and B_A_vars == []:
		return Product(A_new, B_new)
	else:
		return feedback2(Serial(A_new, B_new, A_B_vars), B_A_vars, opt_comp)
	'''
	TO CHECK: this has been removed to not change the topological order
	elif len(B_A_vars) < len(A_B_vars):
		return feedback2(Serial(A_new, B_new, A_B_vars), B_A_vars, opt_comp)
	else:
		return feedback2(Serial(B_new, A_new, B_A_vars), A_B_vars, opt_comp)
	'''



'''
def compose2(def_blocks, A, B):
	if A == None:
		return B
	A_B_vars = [v for v in A.outport if v in B.inport]
	B_A_vars = [v for v in B.outport if v in A.inport]

	if A_B_vars == [] and B_A_vars == []:
		return Product(A, B)
	
	elif len(B_A_vars) < len(A_B_vars):
		return feedback(def_blocks, Serial(A, B, A_B_vars), B_A_vars)
	else:
		return feedback(def_blocks, Serial(B, A, B_A_vars), A_B_vars)
'''

def compose2(def_blocks, A, B):
	if A == None:
		B_new = compose_comp_feedback(B, opt_comp)
		return B_new
		
	A_new = compose_comp_feedback(A, opt_comp)
	B_new = compose_comp_feedback(B, opt_comp)		
	
	A_B_vars = [v for v in A_new.outport if v in B_new.inport]
	B_A_vars = [v for v in B_new.outport if v in A_new.inport]

	if A_B_vars == [] and B_A_vars == []:
		return Product(A_new, B_new)
	
	elif len(B_A_vars) < len(A_B_vars):
		return feedback(def_blocks, Serial(A_new, B_new, A_B_vars), B_A_vars)
	else:
		return feedback(def_blocks, Serial(B_new, A_new, B_A_vars), A_B_vars)


# Defines a class for a component composed from two blocks in parallel not connected by wires
class Product(SimulinkBlock):
	def __init__(self, A, B):
		SimulinkBlock.__init__(self)
		self.type = "Composed"
		self.ctype = "Product"
		self.A = A
		self.B = B
		self.inport = self.A.inport + self.B.inport
		self.outport = self.A.outport + self.B.outport
		# update dependency
	
	def isabelle(self, opt_fun, opt_generic, flag):
		#todo: check for Skip
		a = iSwitch([self.inport], [self.A.inport, self.B.inport], opt_fun)
		b = iProd(self.A.isabelle(opt_fun, opt_generic, False), self.B.isabelle(opt_fun, opt_generic, False))
		c = iSwitch([self.A.outport, self.B.outport], [self.outport], opt_fun)
		return iComp(a, b, c)

# Defines a class for a component composed sequentially from two blocks connected by wires
class Serial(SimulinkBlock):
	def __init__(self, A, B, A_B_vars):
		SimulinkBlock.__init__(self)
		self.type = "Composed"
		self.ctype = "Serial"
		self.A = A
		self.B = B
		self.A_out_vars = [v for v in A.outport if v not in A_B_vars]
		self.B_in_vars = [v for v in B.inport if v not in A_B_vars]
		self.inport = self.A.inport + self.B_in_vars
		self.outport = self.B.outport + self.A_out_vars

	def isabelle(self, opt_fun, opt_generic, flag):
		# todo: check for Skip
		if self.B_in_vars != []:
			a = iSwitch([self.inport], [self.A.inport, self.B_in_vars], opt_fun)
			b = iComp(a, iProd(self.A.isabelle(opt_fun, opt_generic, False), iSkip()))
			x = [self.A.outport, self.B_in_vars]
		else:
			b = self.A.isabelle(opt_fun, opt_generic, False)
			x = [self.A.outport]
			
		if self.A_out_vars != []:
			d = iProd(self.B.isabelle(opt_fun, opt_generic, False), iSkip())
			e = iComp(d, iSwitch([self.B.outport, self.A_out_vars], [self.outport], opt_fun))
			y = [self.B.inport, self.A_out_vars]
		else:
			e = self.B.isabelle(opt_fun, opt_generic, False)
			y = [self.B.inport]
			
		c = iSwitch(x, y, opt_fun)
		
		return iComp(b, c, e)
	
# Defines a class for a (composed) component on which feedback has to be applied
class Feedback(SimulinkBlock):
	def __init__(self, A, feedback_vars, has_io, opt_comp):
		SimulinkBlock.__init__(self)
		self.A = A
		self.ctype = "Feedback"
		self.feedback_vars = feedback_vars
		self.inport = [x for x in A.inport if not x in feedback_vars]
		self.outport = [x for x in A.outport if not x in feedback_vars]
		self.has_io = has_io
		if opt_comp == "ic":
			self.op_comp = True
		else:
			self.op_comp = False

	def isabelle(self, opt_fun, opt_generic, flag):
		#a = iSwitch([self.feedback_vars, self.inport],[self.A.inport], opt_fun)
		#b = iSwitch([self.A.outport], [self.feedback_vars, self.outport], opt_fun)
		gen_unit = 2
		if not self.has_io and len(self.inport) == 0:
			gen_unit = 1
		#print gen_unit
		#parentId, selfId, pType, arity, var_name = None)
		
		
		#print "FEEDBACK"
		
		if len((self.inport)) > 0:
			sw1 = iSwitch([self.feedback_vars + self.inport],[self.A.inport], opt_fun)
		else:
			sw1 = iSwitchSplit([self.feedback_vars  + [Port(0, 0, "unit", 1, "UnitVal")]],[self.A.inport], opt_fun)
			#print "input 0 - switch"


		if len((self.outport)) > 0:
			sw2 = iSwitch([self.A.outport], [self.feedback_vars + self.outport], opt_fun)
		else:
			#sw2 = iSwitchSplit([self.A.outport], [self.feedback_vars] + [[]], opt_fun)
			#sw2 = iSwitchSplit([self.A.outport], [self.feedback_vars + [Port(0, 0, "unit", 1, "UnitVal")]] + [[]], opt_fun)
			sw2 = iSwitchSplit([self.A.outport], [self.feedback_vars + [Port(0, 0, "unit", 1, "UnitVal")]], opt_fun)
			#print "output 0 - switch"		
					
		r = iComp(sw1, self.A.isabelle(opt_fun, opt_generic, False), sw2)
		#return iFeedback(r, len(self.feedback_vars), opt_fun, self.op_comp)
		return iFeedback(r, len(self.feedback_vars), opt_fun, False) #!!!! changed

class SeqFeedback(SimulinkBlock):
	def __init__(self, definition_blocks, A, feedback_vars):
		SimulinkBlock.__init__(self)
		self.type = "Composed"
		self.ctype = "Feedback"
		self.name = 't' + str(utilities.simulink_globals.tindex)
		utilities.simulink_globals.tindex = utilities.simulink_globals.tindex + 1	
		
		fv = feedback_vars
		#print 
		#print "feedback var", fv
		#print
		
		self.blocks = []
		
		#print "FEEDBACK"

		
		if len(fv) != 1:
			#print "fv > 1"
			aux = SeqFeedback(definition_blocks, A, fv[1:])
			definition_blocks.append(aux)
			self.blocks.append(aux)
			self.formula = Feedback(aux, [fv[0]], True, "fp")
		else:
			if len(fv) == 1:
				#print "fv = 1"
				self.formula = Feedback(A, [fv[0]], True, "fp")
				self.blocks.append(A)

		'''if len(fv) == 1:
			self.formula = Feedback(A, fv)
			self.blocks.append(A)
		else:
			aux = SeqFeedback(definition_blocks, A, fv[1:])
			definition_blocks.append(aux)
			self.blocks.append(aux)
			self.formula = Feedback(aux, [fv[0]])
		'''
		
		self.inport = self.formula.inport
		self.outport = self.formula.outport	
		
		for b in self.blocks:
			if b.get_params() != "":
				self.set_params(b.get_params_list())
				#self.set_params("dt")
				#break
		
	def isabelle(self, opt_fun, opt_generic, flag):
		# 
		res = ""
		if flag:
			res = self.formula.isabelle(opt_fun, opt_generic, False)
		else:
			res = iBasic(self.get_name(), self.get_params_list())
		return res

	def get_dependent_blocks(self):
		res = []
		for p in self.blocks:
			if p.get_type() == 'Composed':
				res.append(p.get_name())
		return res
		

# Defines a class for a component obtained from the sequential composition of several components
class ISerialComposition(SimulinkBlock):
	def __init__(self, definition_blocks, sid, name, block_list):
		SimulinkBlock.__init__(self)

		self.sid = sid
		self.type = "Composed"
		if self.name == None:
			self.name = 't' + str(utilities.simulink_globals.tindex)
		else:
			self.name = name
		utilities.simulink_globals.tindex = utilities.simulink_globals.tindex + 1
		
		
		#bl = sort_blocks2(block_list)
		#print bl
		bl = block_list
		self.formula = None
		self.blocks = []
		
		if len(bl) == 2:
			self.formula = compose(bl[1], bl[0], "ioic")
			self.blocks.append(bl[1])
			self.blocks.append(bl[0])
		else:
			aux3 = bl[0]
			aux4 = ISerialComposition(definition_blocks, self.name, self.name, bl[1:])
			definition_blocks.append(aux4)
			self.blocks.append(aux3)
			self.blocks.append(aux4)
			self.formula = compose(aux3, aux4, "ioic")

		'''if len(block_list) == 2:
			self.formula = compose(block_list[0], block_list[1])
			self.blocks.append(block_list[0])
			self.blocks.append(block_list[1])
		else:
			aux3 = block_list[0]
			aux4 = ISerialComposition(definition_blocks, self.name, self.name, block_list[1:], opt_fun)
			definition_blocks.append(aux4)
			self.blocks.append(aux3)
			self.blocks.append(aux4)
			self.formula = compose(aux3, aux4)
		'''
		
		self.inport = self.formula.inport
		self.outport = self.formula.outport	
		
		for b in self.blocks:
			if b.get_params() != "":
				self.set_params(b.get_params_list())
				#self.set_params("dt")
				#break

	def isabelle(self, opt_fun, opt_generic, flag):
		# 
		res = ""
		if flag:
			res = self.formula.isabelle(opt_fun, opt_generic, False)
		else:
			res = iBasic(self.get_name(), self.get_params_list())
		return res

	def get_dependent_blocks(self):
		res = []
		for p in self.blocks:
			if p.get_type() == 'Composed':
				res.append(p.get_name())
		return res


class CSerialComposition(SimulinkBlock):
	def __init__(self, sid, name, blocks):
		SimulinkBlock.__init__(self)
		self.sid = sid
		self.name = name
		self.type = "Composed"
		
		for b in blocks:
			if b.get_params() != "":
				self.set_params(b.get_params_list())
				#self.set_params("dt")
				#break	
		
		self.dep_blocks = []
		for b in blocks:
			if b.get_type() == 'Composed':
				self.dep_blocks.append(b.get_name())
		
		self.formula = None
		#self.block_list = []
		
		#bl = sort_blocks(blocks)
		bl = blocks
		for kb in bl:
			self.formula = compose(self.formula, kb, "ic")
			#self.block_list.append(kb)
		
		#print self.formula.get_ctype()
		self.inport = self.formula.inport
		self.outport = self.formula.outport	
		
	def isabelle(self, opt_fun, opt_generic, flag):
		res = ""
		if flag:
			res = self.formula.isabelle(opt_fun, opt_generic, False)
		else:
			res = iBasic(self.get_name(), self.get_params_list())
		return res

	def get_dependent_blocks(self):
		return self.dep_blocks

'''
class MonolithicComposition(SimulinkBlock):
	def __init__(self, definition_blocks, sid, name, blocks, opt_fun):
		SimulinkBlock.__init__(self)
		
		self.name = name
		self.type = 'Composed'
		self.blocks = []
		
		for b in blocks:
			if b.get_params() != "":
				self.set_params(b.get_params_list())
		
		A = MonolithicCompositionNFB(sid, name, blocks, opt_fun)
		definition_blocks.append(A)
		self.formula = feedback(definition_blocks, A, A.common_var[::-1])
		#self.formula = feedback2(A, A.common_var[::-1])
		if self.formula.get_params() != "":
				self.set_params(self.formula.get_params_list())
				#self.set_params("dt")
		definition_blocks.append(self.formula)
		self.blocks.append(self.formula)	
		self.blocks.append(A)
		self.inport = self.formula.inport
		self.outport = self.formula.outport
	
	def isabelle(self, opt_fun, flag):
		if flag:
			res = self.formula.isabelle(opt_fun, False)
		else:
			res = "(" + self.get_name() + " " + self.get_params() + ")"
		return res
			
	def get_dependent_blocks(self):
		res = []
		for p in self.blocks:
			if p.get_type() == 'Composed':
				res.append(p.get_name())
		return res
'''

# Defines a class for a component obtained from the parallel composition of several components (one general feedback)		
class MonolithicCompositionNFB(SimulinkBlock):
	def __init__(self, sid, name, blocks, opt_fun):
		SimulinkBlock.__init__(self)
		self.sid = sid
		self.name = "C"+name
		self.type = 'Composed'

		
		for b in blocks:
			if b.get_params() != "":
				self.set_params(b.get_params_list())
				#self.set_params("dt")
				#break	
		
		self.dep_blocks = []
		for b in blocks:
			if b.get_type() == 'Composed':
				self.dep_blocks.append(b.get_name())

				
		split_in = [block.inport for block in blocks]
		all_in = [x for y in split_in for x in y]
		#print split_in
		#print all_in 
		split_out = [block.outport for block in blocks]
		all_out = [x for y in split_out for x in y]
		#print split_out
		#print all_out
		
		self.common_var = [x for x in all_in if x in all_out]
		#print self.common_var
		
		unc_in = [x for x in all_in if not x in self.common_var]
		unc_out = [x for x in all_out if not x in self.common_var]
		
		self.inport = self.common_var + unc_in
		#print self.inport
		self.outport = self.common_var + unc_out
		
		isabelle_block_list = [b.isabelle(opt_fun, False, False) for b in blocks]
		prod = iProd(*isabelle_block_list)
		
		A = iSwitch([self.inport], split_in, opt_fun, 0)
		B = iSwitch(split_out, [self.outport], opt_fun, 0)
		self.expr = iComp(A,prod,B)

	def isabelle(self, opt_fun, opt_generic, flag):
		if flag:
			res = self.expr
		else:
			res = iBasic(self.get_name(), self.get_params_list())
		return res
		
		
	def get_dependent_blocks(self):
		return self.dep_blocks


class MonolithicComposition(SimulinkBlock):
	def __init__(self, definition_blocks, sid, name, blocks, opt_fun):
		SimulinkBlock.__init__(self)
		self.sid = sid
		#self.name = "C"+name
		self.name = name
		self.type = 'Composed'

		
		for b in blocks:
			if b.get_params() != "":
				self.set_params(b.get_params_list())
		
		self.dep_blocks = []
		for b in blocks:
			if b.get_type() == 'Composed':
				self.dep_blocks.append(b.get_name())

				
		split_in = [block.inport for block in blocks]
		split_out = [block.outport for block in blocks]
		all_in = [j for k in split_in for j in k]
		all_out = [j for k in split_out for j in k]
		self.common_var = [x for x in all_in if x in all_out]
		#self.inport = [x for x in all_in if not x in self.common_var]
		#self.outport = [x for x in all_out if not x in self.common_var]
		
		unc_in = [x for x in all_in if not x in self.common_var]
		unc_out = [x for x in all_out if not x in self.common_var]
		
		self.inport = unc_in
		self.outport = unc_out
		
		isabelle_block_list = [b.isabelle(opt_fun, False, False) for b in blocks]
		prod = iProd(*isabelle_block_list)
		#modified for multiple fbd
		
		#print "common vars:", len(self.common_var)
		#print "unc_in: ", unc_in
		#print "unc_out: ", unc_out
		
		#viorel
		if unc_in == []:
			unc_in = [Port(0, 0, "unit", 1, "UnitVal")]

		if unc_out == []:
			unc_out = [Port(0, 0, "unit", 1, "UnitVal")]
			#unc_out = [[]]
			
		A = iSwitchSplit([self.common_var + unc_in], split_in, opt_fun)
		B = iSwitchSplit(split_out, [self.common_var + unc_out], opt_fun)

		self.expr = iFeedback(iComp(A, prod, B), len(self.common_var), opt_fun, False) #!! changed
		#self.expr = iFeedback(iComp(A, prod, B), len(self.common_var), opt_fun, True)


	def isabelle(self, opt_fun, opt_generic, flag):
		if flag:
			res = self.expr
		else:
			res = iBasic(self.get_name(), self.get_params_list())
		return res

	def get_dependent_blocks(self):
		return self.dep_blocks


'''# Defines a class for a component obtained from the parallel composition of several components (one general feedback)		
class MonolithicCompositionNFB(SimulinkBlock):
	def __init__(self, sid, name, blocks, opt_fun):
		SimulinkBlock.__init__(self)
		self.sid = sid
		self.name = "C"+name
		self.type = 'Composed'

		
		for b in blocks:
			if b.get_params() != "":
				self.set_params("dt")
				break	
		
		self.dep_blocks = []
		for b in blocks:
			if b.get_type() == 'Composed':
				self.dep_blocks.append(b.get_name())

				
		split_in = [block.inport for block in blocks]
		split_out = [block.outport for block in blocks]
		all_in = [j for k in split_in for j in k]
		all_out = [j for k in split_out for j in k]
		self.common_var = [x for x in all_in if x in all_out]
		#self.inport = [x for x in all_in if not x in self.common_var]
		#self.outport = [x for x in all_out if not x in self.common_var]
		
		unc_in = [x for x in all_in if not x in self.common_var]
		unc_out = [x for x in all_out if not x in self.common_var]
		
		self.inport = self.common_var + unc_in
		self.outport = self.common_var + unc_out
		
		isabelle_block_list = [b.isabelle(opt_fun, False) for b in blocks]
		prod = iProd(*isabelle_block_list)
		#modified for multiple fbd
		A = iSwitch([self.common_var + unc_in], split_in, opt_fun)
		B = iSwitch(split_out, [self.common_var + unc_out], opt_fun)
		self.expr = iComp(A,prod,B)
		#self.expr = iFeedback(iComp(A, prod, B), len(common_var))

	def isabelle(self, opt_fun, flag):
		if flag:
			return self.expr
		else:
			return self.get_name()

	def get_dependent_blocks(self):
		return self.dep_blocks
'''
