# -*- coding: utf-8 -*-

import os

def rnpath(p): 
	return os.path.realpath(os.path.normpath(p))

def get_isa_theories_path(currentFolder):

	homeFolder = rnpath(currentFolder.rstrip("Simulink2Isabelle"))
	theoriesFolder = rnpath(os.path.join(homeFolder, "Isabelle"))
	return theoriesFolder


def get_rel_path(filename, currentFolder):
	isa_path = get_isa_theories_path(currentFolder)
	file_path = rnpath(filename)
	
	common_prefix_aux = os.path.commonprefix([isa_path, file_path])
	if common_prefix_aux.endswith("/"):
		common_prefix = common_prefix_aux
	else:
		common_prefix = os.path.split(common_prefix_aux)[0]
	
	rel_fp = os.path.relpath(common_prefix, file_path).rstrip("..")
	rel_ip = os.path.relpath(isa_path, common_prefix)
	p = os.path.join(rel_fp,rel_ip)
	
	return p

def get_sim_rel_path(filename, currentFolder):
	homeFolder = rnpath(currentFolder)
	file_path = rnpath(filename)
	
	common_prefix_aux = os.path.commonprefix([homeFolder, file_path])
	if common_prefix_aux.endswith("/"):
		common_prefix = common_prefix_aux
	else:
		common_prefix = os.path.split(common_prefix_aux)[0]
	
	rel_fp = os.path.relpath(common_prefix, file_path).rstrip("..")
	rel_ip = os.path.relpath(homeFolder, common_prefix)
	p = os.path.join(rel_fp,rel_ip)
	
	return p

def get_sim_theory_path(filename, currentFolder):
	return os.path.normpath(os.path.join(get_rel_path(filename, currentFolder), "Simulink", "SimplifyRCRS"))
	
def get_py_theory_path(filename, currentFolder):
	return os.path.normpath(os.path.join(get_rel_path(filename, currentFolder), "Simulink", "PythonSimulation"))

def get_iter_theory_path(filename, currentFolder):
	return os.path.normpath(os.path.join(get_rel_path(filename, currentFolder), "Feedback", "IterateOperators"))
